t/: Replace diff [-u|-U0] with test_cmp to allow compilation with old diff
[git/dscho.git] / git-bisect.sh
blob3cac20db79e1e408a321b0e9d272501985a3c49b
1 #!/bin/sh
3 USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect help
5 print this long help message.
6 git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7 reset bisect state and start bisection.
8 git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10 git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
12 git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
14 git bisect next
15 find next bisection to test and check it out.
16 git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18 git bisect visualize
19 show bisect status in gitk.
20 git bisect replay <logfile>
21 replay bisection log.
22 git bisect log
23 show bisect log.
24 git bisect run <cmd>...
25 use <cmd>... to automatically bisect.
27 Please use "git help bisect" to get the full man page.'
29 OPTIONS_SPEC=
30 . git-sh-setup
31 require_work_tree
33 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
36 sq() {
37 @@PERL@@ -e '
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
42 print "\n";
43 ' "$@"
46 bisect_autostart() {
47 test -s "$GIT_DIR/BISECT_START" || {
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
64 bisect_start() {
66 # Verify HEAD.
68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
73 # Check if we are bisecting.
75 start_head=''
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
93 die "Bad HEAD - strange symbolic ref"
95 esac
99 # Get rid of any old bisect state.
101 bisect_clean_state || exit
104 # Check for one bad and then some good revisions.
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
112 eval=''
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
117 shift
118 break
121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
131 shift
133 esac
134 done
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
147 # Write new start state.
149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
151 eval "$eval" &&
152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
154 # Check if we can proceed to the next bisect state.
156 bisect_auto_next
158 trap '-' 0
161 bisect_write() {
162 state="$1"
163 rev="$2"
164 nolog="$3"
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
170 git update-ref "refs/bisect/$tag" "$rev" || exit
171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
175 bisect_state() {
176 bisect_autostart
177 state=$1
178 case "$#,$state" in
179 0,*)
180 die "Please call 'bisect_state' with at least one argument." ;;
181 1,bad|1,good|1,skip)
182 rev=$(git rev-parse --verify HEAD) ||
183 die "Bad rev input: HEAD"
184 bisect_write "$state" "$rev" ;;
185 2,bad|*,good|*,skip)
186 shift
187 eval=''
188 for rev in "$@"
190 sha=$(git rev-parse --verify "$rev^{commit}") ||
191 die "Bad rev input: $rev"
192 eval="$eval bisect_write '$state' '$sha'; "
193 done
194 eval "$eval" ;;
195 *,bad)
196 die "'git bisect bad' can take only one argument." ;;
198 usage ;;
199 esac
200 bisect_auto_next
203 bisect_next_check() {
204 missing_good= missing_bad=
205 git show-ref -q --verify refs/bisect/bad || missing_bad=t
206 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
208 case "$missing_good,$missing_bad,$1" in
209 ,,*)
210 : have both good and bad - ok
213 # do not have both but not asked to fail - just report.
214 false
216 t,,good)
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
220 if test -t 0
221 then
222 printf >&2 'Are you sure [Y/n]? '
223 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
225 : bisect without good...
228 THEN=''
229 test -s "$GIT_DIR/BISECT_START" || {
230 echo >&2 'You need to start by "git bisect start".'
231 THEN='then '
233 echo >&2 'You '$THEN'need to give me at least one good' \
234 'and one bad revisions.'
235 echo >&2 '(You can use "git bisect bad" and' \
236 '"git bisect good" for that.)'
237 exit 1 ;;
238 esac
241 bisect_auto_next() {
242 bisect_next_check && bisect_next || :
245 eval_rev_list() {
246 _eval="$1"
248 eval $_eval
249 res=$?
251 if [ $res -ne 0 ]; then
252 echo >&2 "'git rev-list --bisect-vars' failed:"
253 echo >&2 "maybe you mistake good and bad revs?"
254 exit $res
257 return $res
260 filter_skipped() {
261 _eval="$1"
262 _skip="$2"
264 if [ -z "$_skip" ]; then
265 eval_rev_list "$_eval"
266 return
269 # Let's parse the output of:
270 # "git rev-list --bisect-vars --bisect-all ..."
271 eval_rev_list "$_eval" | while read hash line
273 case "$VARS,$FOUND,$TRIED,$hash" in
274 # We display some vars.
275 1,*,*,*) echo "$hash $line" ;;
277 # Split line.
278 ,*,*,---*) ;;
280 # We had nothing to search.
281 ,,,bisect_rev*)
282 echo "bisect_rev="
283 VARS=1
286 # We did not find a good bisect rev.
287 # This should happen only if the "bad"
288 # commit is also a "skip" commit.
289 ,,*,bisect_rev*)
290 echo "bisect_rev=$TRIED"
291 VARS=1
294 # We are searching.
295 ,,*,*)
296 TRIED="${TRIED:+$TRIED|}$hash"
297 case "$_skip" in
298 *$hash*) ;;
300 echo "bisect_rev=$hash"
301 echo "bisect_tried=\"$TRIED\""
302 FOUND=1
304 esac
307 # We have already found a rev to be tested.
308 ,1,*,bisect_rev*) VARS=1 ;;
309 ,1,*,*) ;;
311 # ???
312 *) die "filter_skipped error " \
313 "VARS: '$VARS' " \
314 "FOUND: '$FOUND' " \
315 "TRIED: '$TRIED' " \
316 "hash: '$hash' " \
317 "line: '$line'"
319 esac
320 done
323 exit_if_skipped_commits () {
324 _tried=$1
325 if expr "$_tried" : ".*[|].*" > /dev/null ; then
326 echo "There are only 'skip'ped commit left to test."
327 echo "The first bad commit could be any of:"
328 echo "$_tried" | tr '[|]' '[\012]'
329 echo "We cannot bisect more!"
330 exit 2
334 bisect_next() {
335 case "$#" in 0) ;; *) usage ;; esac
336 bisect_autostart
337 bisect_next_check good
339 skip=$(git for-each-ref --format='%(objectname)' \
340 "refs/bisect/skip-*" | tr '\012' ' ') || exit
342 BISECT_OPT=''
343 test -n "$skip" && BISECT_OPT='--bisect-all'
345 bad=$(git rev-parse --verify refs/bisect/bad) &&
346 good=$(git for-each-ref --format='^%(objectname)' \
347 "refs/bisect/good-*" | tr '\012' ' ') &&
348 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
349 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
350 eval=$(filter_skipped "$eval" "$skip") &&
351 eval "$eval" || exit
353 if [ -z "$bisect_rev" ]; then
354 echo "$bad was both good and bad"
355 exit 1
357 if [ "$bisect_rev" = "$bad" ]; then
358 exit_if_skipped_commits "$bisect_tried"
359 echo "$bisect_rev is first bad commit"
360 git diff-tree --pretty $bisect_rev
361 exit 0
364 # We should exit here only if the "bad"
365 # commit is also a "skip" commit (see above).
366 exit_if_skipped_commits "$bisect_rev"
368 echo "Bisecting: $bisect_nr revisions left to test after this"
369 git checkout -q "$bisect_rev" || exit
370 git show-branch "$bisect_rev"
373 bisect_visualize() {
374 bisect_next_check fail
376 if test $# = 0
377 then
378 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
379 '') set git log ;;
380 set*) set gitk ;;
381 esac
382 else
383 case "$1" in
384 git*|tig) ;;
385 -*) set git log "$@" ;;
386 *) set git "$@" ;;
387 esac
390 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
391 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
394 bisect_reset() {
395 test -s "$GIT_DIR/BISECT_START" || {
396 echo "We are not bisecting."
397 return
399 case "$#" in
400 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
401 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
402 die "$1 does not seem to be a valid branch"
403 branch="$1" ;;
405 usage ;;
406 esac
407 git checkout "$branch" && bisect_clean_state
410 bisect_clean_state() {
411 # There may be some refs packed during bisection.
412 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
413 while read ref hash
415 git update-ref -d $ref $hash || exit
416 done
417 rm -f "$GIT_DIR/BISECT_LOG" &&
418 rm -f "$GIT_DIR/BISECT_NAMES" &&
419 rm -f "$GIT_DIR/BISECT_RUN" &&
420 # Cleanup head-name if it got left by an old version of git-bisect
421 rm -f "$GIT_DIR/head-name" &&
423 rm -f "$GIT_DIR/BISECT_START"
426 bisect_replay () {
427 test -r "$1" || die "cannot read $1 for replaying"
428 bisect_reset
429 while read git bisect command rev
431 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
432 if test "$git" = "git-bisect"; then
433 rev="$command"
434 command="$bisect"
436 case "$command" in
437 start)
438 cmd="bisect_start $rev"
439 eval "$cmd" ;;
440 good|bad|skip)
441 bisect_write "$command" "$rev" ;;
443 die "?? what are you talking about?" ;;
444 esac
445 done <"$1"
446 bisect_auto_next
449 bisect_run () {
450 bisect_next_check fail
452 while true
454 echo "running $@"
455 "$@"
456 res=$?
458 # Check for really bad run error.
459 if [ $res -lt 0 -o $res -ge 128 ]; then
460 echo >&2 "bisect run failed:"
461 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
462 exit $res
465 # Find current state depending on run success or failure.
466 # A special exit code of 125 means cannot test.
467 if [ $res -eq 125 ]; then
468 state='skip'
469 elif [ $res -gt 0 ]; then
470 state='bad'
471 else
472 state='good'
475 # We have to use a subshell because "bisect_state" can exit.
476 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
477 res=$?
479 cat "$GIT_DIR/BISECT_RUN"
481 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
482 > /dev/null; then
483 echo >&2 "bisect run cannot continue any more"
484 exit $res
487 if [ $res -ne 0 ]; then
488 echo >&2 "bisect run failed:"
489 echo >&2 "'bisect_state $state' exited with error code $res"
490 exit $res
493 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
494 echo "bisect run success"
495 exit 0;
498 done
502 case "$#" in
504 usage ;;
506 cmd="$1"
507 shift
508 case "$cmd" in
509 help)
510 git bisect -h ;;
511 start)
512 bisect_start "$@" ;;
513 bad|good|skip)
514 bisect_state "$cmd" "$@" ;;
515 next)
516 # Not sure we want "next" at the UI level anymore.
517 bisect_next "$@" ;;
518 visualize|view)
519 bisect_visualize "$@" ;;
520 reset)
521 bisect_reset "$@" ;;
522 replay)
523 bisect_replay "$@" ;;
524 log)
525 cat "$GIT_DIR/BISECT_LOG" ;;
526 run)
527 bisect_run "$@" ;;
529 usage ;;
530 esac
531 esac